
_debounce:

;PWM.c,13 :: 		void debounce(){
;PWM.c,14 :: 		Delay_ms(300);
	MOVLW      2
	MOVWF      R11+0
	MOVLW      134
	MOVWF      R12+0
	MOVLW      153
	MOVWF      R13+0
L_debounce0:
	DECFSZ     R13+0, 1
	GOTO       L_debounce0
	DECFSZ     R12+0, 1
	GOTO       L_debounce0
	DECFSZ     R11+0, 1
	GOTO       L_debounce0
;PWM.c,15 :: 		}
	RETURN
; end of _debounce

_main:

;PWM.c,17 :: 		void main() {
;PWM.c,18 :: 		CMCON = 0x07;
	MOVLW      7
	MOVWF      CMCON+0
;PWM.c,19 :: 		PORTB = 0x00; // Initial state of port B
	CLRF       PORTB+0
;PWM.c,20 :: 		TRISB = 0b00000011; // RB0, RB1 input, RB3 (PWM1) output
	MOVLW      3
	MOVWF      TRISB+0
;PWM.c,21 :: 		PWM1_Init(5000); // PWM module initialization (5KHz)
	BCF        T2CON+0, 0
	BCF        T2CON+0, 1
	MOVLW      199
	MOVWF      PR2+0
	CALL       _PWM1_Init+0
;PWM.c,22 :: 		new_DC = 0; // Initial value of variable Duty Cycle
	CLRF       _new_DC+0
;PWM.c,23 :: 		current_DC = 0;
	CLRF       _current_DC+0
;PWM.c,24 :: 		PWM1_Start(); // Start PWM1 module with Zero DC
	CALL       _PWM1_Start+0
;PWM.c,25 :: 		PWM1_Set_Duty(current_DC);
	MOVF       _current_DC+0, 0
	MOVWF      FARG_PWM1_Set_Duty_new_duty+0
	CALL       _PWM1_Set_Duty+0
;PWM.c,26 :: 		do {
L_main1:
;PWM.c,27 :: 		if (!UP){ // If the button connected to RB0 is pressed
	BTFSC      RB0_bit+0, 0
	GOTO       L_main4
;PWM.c,28 :: 		debounce();
	CALL       _debounce+0
;PWM.c,29 :: 		if (new_DC < 250)         // Don't go above 250
	MOVLW      250
	SUBWF      _new_DC+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L_main5
;PWM.c,30 :: 		new_DC = new_DC + 25 ; // increment Duty Cycle by 25
	MOVLW      25
	ADDWF      _new_DC+0, 1
L_main5:
;PWM.c,31 :: 		}
L_main4:
;PWM.c,32 :: 		if (!DOWN) { // If the button connected to RB1 is pressed
	BTFSC      RB1_bit+0, 1
	GOTO       L_main6
;PWM.c,33 :: 		debounce();
	CALL       _debounce+0
;PWM.c,34 :: 		if (new_DC !=0)                 // Don't go below 0
	MOVF       _new_DC+0, 0
	XORLW      0
	BTFSC      STATUS+0, 2
	GOTO       L_main7
;PWM.c,35 :: 		new_DC= new_DC - 25 ; // decrement Duty Cycle by 25
	MOVLW      25
	SUBWF      _new_DC+0, 1
L_main7:
;PWM.c,36 :: 		}
L_main6:
;PWM.c,38 :: 		if (current_DC != new_DC) {
	MOVF       _current_DC+0, 0
	XORWF      _new_DC+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main8
;PWM.c,39 :: 		current_DC = new_DC ;
	MOVF       _new_DC+0, 0
	MOVWF      _current_DC+0
;PWM.c,40 :: 		PWM1_Set_Duty(current_DC); // Change the current DC to new value
	MOVF       _new_DC+0, 0
	MOVWF      FARG_PWM1_Set_Duty_new_duty+0
	CALL       _PWM1_Set_Duty+0
;PWM.c,41 :: 		}
L_main8:
;PWM.c,42 :: 		} while(1);
	GOTO       L_main1
;PWM.c,43 :: 		}  // END main()
	GOTO       $+0
; end of _main
